# bdm::Kalman< sq_T > Class Template Reference

Common abstract base for Kalman filters. More...

## Detailed Description

### template<class sq_T>
class bdm::Kalman< sq_T >

Common abstract base for Kalman filters.

`#include <kalman.h>`

List of all members.

## Public Member Functions
| Kalman (const Kalman< sq_T > &K0)
| Copy constructor.
void | set_statistics (const vec &mu0, const mat &P0)
| set statistics of the posterior
void | set_statistics (const vec &mu0, const sq_T &P0)
| set statistics of the posterior
const enorm< sq_T > & | posterior () const
| return correctly typed posterior (covariant return)
shared_ptr< epdf > | shared_posterior ()
| shared posterior
void | from_setting (const Setting &set)
| load basic elements of Kalman from structure
void | validate ()
| validate object
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
void | set_parameters (const mat &A0, const mat &B0, const mat &C0, const mat &D0, const sq_T &Q0, const sq_T &R0)
| set all matrix parameters
int | _dimx ()
| access function
int | _dimy ()
| access function
int | _dimu ()
| access function
const mat & | _A () const
| access function
const mat & | _B () const
| access function
const mat & | _C () const
| access function
const mat & | _D () const
| access function
const sq_T & | _Q () const
| access function
const sq_T & | _R () const
| access function
Constructors
virtual BM * | _copy_ () const
| Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:.
Mathematical operations
virtual void | bayes (const vec &dt)=0
| Incremental Bayes rule.
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs conditional density of 1-step ahead predictor .
Access to attributes
access function
const RV & | _drv () const
void | set_drv (const RV &rv)
| access function
void | set_rv (const RV &rv)
| access to rv of the posterior
double | _ll () const
| return internal log-likelihood of the last data vector
void | set_evalll (bool evl0)
| switch evaluation of log-likelihood on/off
## Protected Attributes
RV | yrv
| id of output
RV | urv
| id of input
mat | _K
| Kalman gain.
shared_ptr< enorm< sq_T > > | est
| posterior
enorm< sq_T > | fy
| marginal on data f(y|y)
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
int | dimx
| cache of rv.count()
int | dimy
| cache of rvy.count()
int | dimu
| cache of rvu.count()
mat | A
| Matrix A.
mat | B
| Matrix B.
mat | C
| Matrix C.
mat | D
| Matrix D.
sq_T | Q
| Matrix Q in square-root form.
sq_T | R
| Matrix R in square-root form.
## Extension to conditional BM
This extension is useful e.g. in Marginalized Particle Filter (bdm::MPF). Alternatively, it can be used for automated connection to DS when the condition is observed
const RV & | _rvc () const
| access function
virtual void | condition (const vec &val)
| Substitute `val` for `rvc`.
RV | rvc
| Name of extension variable.
## Logging of results
virtual void | set_options (const string &opt)
| Set boolean options from a string, recognized are: "logbounds,logll".
virtual void | log_add (logger &L, const string &name="")
| Add all logged variables to a logger.
virtual void | logit (logger &L)
| Save results to the given logger, details of what is stored is configured by `LIDs` and `options`.
ivec | LIDs
| IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll].
ivec | LFlags
| Flags for logging - same size as LIDs, each entry correspond to the same in LIDs.

## Member Function Documentation

virtual BM* bdm::BM::_copy_ | ( |  | ) | const`[inline, virtual, inherited]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:.

     BM* _copy_() const {return new BM(*this);}

Reimplemented in bdm::ARX, bdm::ARXfrg, bdm::KalmanFull, bdm::KalmanCh, bdm::EKFCh, and bdm::BMEF.

Referenced by bdm::MPF::set_BM().

virtual void bdm::BM::bayes | ( | const vec & | dt | ) | `[pure virtual, inherited]`

Incremental Bayes rule.

Parameters:

  | dt | vector of input data

Implemented in bdm::ARX, bdm::KalmanFull, bdm::KalmanCh, bdm::EKFfull, bdm::EKFCh, bdm::MultiModel, bdm::MixEF, bdm::PF, bdm::MPF, bdm::mexBM, bdm::BMEF, and bdm::multiBM.

Referenced by bdm::BM::bayesB().

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

References bdm_error.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following file:

- kalman.h